chiark / gitweb /
Test suite: Move most of mustfail into t-expect-fail
[dgit.git] / tests / tests / drs-push-rejects
index 36d4dab94602cbc87ae0c4d12c040b50635e99be..13567c3f3a7b771ca235af9589fdb5f8524310aa 100755 (executable)
@@ -10,37 +10,21 @@ t-worktree drs
 
 cd $p
 
-reporefs () {
-       (set -e
-       if test -d $tmp/git/$p.git; then
-               cd $tmp/git/$p.git
-               git show-ref
-       fi)
-}
-
 mustfail () {
-       local wantmsg="$1"; shift
-       reporefs >$tmp/show-refs.pre-push
-       set +e
+       local mpat="$1"; shift
+       t-reporefs pre-push
+
+       t-expect-fail "$mpat" \
        git push origin "$@" 2>&1 |tee $tmp/mustfail.txt
-       ps="${PIPESTATUS[*]}"
-       set -e
-       case $ps in
-       "0 0")  fail "push unexpectedly succeeded (instead of: $wantmsg)" ;;
-       *" 0")  ;;
-       *)      fail "tee failed"  ;;
-       esac
-       if ! fgrep "$wantmsg" $tmp/mustfail.txt >/dev/null; then
-               fail "error message not found"
-       fi
-       reporefs >$tmp/show-refs.post-push
+
+       t-reporefs post-push
        diff $tmp/show-refs.{pre,post}-push
 }
 
 mustsucceed () {
-       reporefs >$tmp/show-refs.pre-push
+       t-reporefs pre-push
        git push origin "$@"
-       reporefs >$tmp/show-refs.post-push
+       t-reporefs post-push
        if diff $tmp/show-refs.{pre,post}-push >$tmp/show-refs.diff; then
                fail "no refs updated"
        fi
@@ -86,7 +70,7 @@ for h in object type tag; do
     cat badtag.asc >>badtag
 
     set +e
-    LC_ALL=C git hash-object -w -t tag badtag >badtag.hash 2>badtag.err
+    LC_MESSAGES=C git hash-object -w -t tag badtag >badtag.hash 2>badtag.err
     rc=$?
     set -e
 
@@ -124,8 +108,13 @@ mustfail 'pushing unexpected ref' $push_spec HEAD:refs/wombat
 mustfail 'pushing multiple heads' $push_spec HEAD:refs/dgit/wombat
 mustfail 'pushing multiple tags' $push_spec HEAD:refs/tags/debian/wombat
 
+prep unstable sid
+mktag
+echo woody >$tmp/suites
+mustfail 'unknown suite' $push_spec
+cp $root/tests/suites $tmp/.
+
 # fixme:
-#    reject "unknown suite";
 #    or reject "command string not understood";
 #    reject "unknown method" unless $mainfunc;
 
@@ -154,8 +143,13 @@ prep unstable sid
 mktag
 mustsucceed $push_spec # succeeds
 
+mktag
+mustfail 'push is missing head ref update' $push_spec
+
+git commit --allow-empty -m 'Dummy update'
 mktag
 mustfail 'not replacing previously-pushed version' $push_spec
+git reset --hard HEAD~
 
 prep_dm_mangle () {
        prep unstable sid